part of nueli.core.bucket;

Gallery get gallery => Gallery.configure();

class Gallery extends Bucket<MediaData> {
  Gallery.configure() : super.configure();
  @override
  Symbol get _iD => #gallery;
}

class MediaData {
  final IconData? data;
  final String? src;
  final String? path;
  MediaData.data(this.data)
      : src = null,
        path = null;
  MediaData.network(this.src)
      : data = null,
        path = null;
  MediaData.assets(this.path)
      : data = null,
        src = null;
}

extension Library_Gallery on Gallery {
  static void configure(
    MediaData flash,
    MediaData flashOff,
    MediaData favorite,
    MediaData favoriteFill,
    MediaData check,
    MediaData checkFill,
  ) {
    (gallery * #flash)[MediaData.data(Icons.flash_on)] = flash;
    (gallery * #flashOff)[MediaData.data(Icons.flash_off)] = flashOff;
    (gallery * #favorite)[MediaData.data(CupertinoIcons.suit_heart)] = favorite;
    (gallery * #favoriteFill)[MediaData.data(CupertinoIcons.suit_heart_fill)] = favoriteFill;
    (gallery * #check)[MediaData.data(CupertinoIcons.checkmark_square)] = flash;
    (gallery * #checkFill)[MediaData.data(CupertinoIcons.checkmark_square_fill)] = flash;
  }

  MediaData get flash => (gallery * #flash)[MediaData.data(Icons.flash_on)];
  MediaData get flashOff => (gallery * #flash_off)[MediaData.data(Icons.flash_off)];
  MediaData get favorite => (gallery * #favorite)[MediaData.data(CupertinoIcons.suit_heart)];
  MediaData get favoriteFill => (gallery * #favoriteFill)[MediaData.data(CupertinoIcons.suit_heart_fill)];
  MediaData get check => (gallery * #check)[MediaData.data(CupertinoIcons.app)];
  MediaData get checkFill => (gallery * #checkFill)[MediaData.data(CupertinoIcons.checkmark_square_fill)];
}
